/*
 * cdnproxy.h
 *
 *  Created on: 2010-5-13
 *      Author: cai
 */

#ifndef CDNPROXY_H_
#define CDNPROXY_H_

#include <glib.h>
#include <zlib.h>

#include "proxy_server.h"

struct Session;
typedef struct Session Session;

struct Session{
	GObject parent;
	ProxyServer * proxy_server;
	GSocket * browser;
	GSocket * cdn;
	gushort	  dest_port;
	gboolean is_ubuntu_cdn;
	gboolean connected;

	//if set, use this
	void	(*http_get_hook)(Session * session);

	gboolean strip_response;

	//打算发送到服务器的东西
	gchar * need_send;
	uLongf  need_send_len;

	guint	step;
	z_stream	zip_stream;
	//后续发送的话
	glong	content_length;
	gchar  * http_header;
	guint http_header_len;
};

typedef struct SessionClass SessionClass;

#define PROXY_TYPE_SESSION proxy_session_get_type()
#define PROXY_SESSION_GET_CLASS(obj)        (G_TYPE_INSTANCE_GET_CLASS ((obj), PROXY_TYPE_SESSION, SessionClass))


GType proxy_session_get_type() G_GNUC_INTERNAL;
Session * proxy_session_new(GSocket* browser,ProxyServer * server) G_GNUC_INTERNAL;

// internal use
void proxy_session_start(Session * session);
gint	proxy_session_get_instence();

#endif /* CDNPROXY_H_ */
